package cli

import (
	"errors"
	"os/exec"
)

// exit returns the exit code depending on the error type.
func exit(err error) int {
	var (
		exit              *exec.ExitError
		expectedParameter *ExpectedParameterError
		unknownParameter  *UnknownParameterError
		invalidValue      *InvalidValueError
	)

	if errors.As(err, &exit) {
		return exit.ExitCode()
	}

	if errors.As(err, &expectedParameter) || errors.As(err, &unknownParameter) || errors.As(err, &invalidValue) {
		return 2
	}

	return 1
}
